package EDU.syr.npac.Gateway;

   import java.net.*;
   import java.io.*;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
//   import EDU.syr.npac.frontend.*;
   import WebFlow.*;
   import org.omg.CORBA.*;
   import WebFlow.FileBrowser.*;

   public class TabbedPane extends JTabbedPane implements FileBrowserListener
   {  

      public TaskPanel taskP;
      public UserPanel userPanel; 
      gw applet;
      String userName,fileRoot,host;
      private ORB orb;
      private FileBrowserCtr FileBrowser=null;


      public TabbedPane(gw applet, String userName, String fileRoot, 
                        String host) {

      this.applet=applet;
      this.userName=userName;
      this.fileRoot=fileRoot;
      this.host=host;
      orb = applet.getORB(); 

      /* cannot do anything untill server is up */ 
         int TimeOut = 100;
         WebFlowContext sv = null;
         boolean non_existent=true; 
	 while(TimeOut>0) {
	   try{
             sv = applet.getSlaves(host);
             non_existent=sv._non_existent();
             if(non_existent) {
               TimeOut--;
	     }
             else {
               TimeOut=-1;
	     }  
             waitForServer(100);
	   } catch (Exception exx) {
               System.out.println(exx);
               TimeOut--;
	   }
	 } 
      waitForServer(100);  //give a chance to start services

      userPanel = new UserPanel(applet,userName);
//      //FileBrowser = new FileBrowserCtr(applet,0,fileRoot);
//      System.out.println("Host: "+host+" start file browser"); 
      
      FileBrowser = new FileBrowserCtr("/", applet.getFileBrowser(), this);
      labelPanel dummyFB = new labelPanel(host); 
//      //      mpJobPanel JobStatus = new mpJobPanel(this,"Job Status"); 
      labelPanel JobStatus = new labelPanel("Job Status"); 
      //taskP = new TaskPanel(applet);

      addTab("User Space",userPanel); 
      //      addTab("Files",dummyFB); 
      addTab("Files",FileBrowser); 
      addTab("Jobs",JobStatus); 
      addTab("Task",taskP);
//      setSelectedComponent(userPanel); 
      System.out.println("Tabbed pane is constructed");
     }

    public synchronized void waitForServer(long delay){
	try {
           wait(delay);
	} catch(InterruptedException e){
		 System.out.println("Intrrupted exc :"+e);
	}
    }

       public void upload(String dest, String source){
	   System.out.println("upload, dest=" + dest + ", source=" + source); 
	   String servlet = "http://" + applet.jhost + ":" + applet.jport + "/servlets/GWMoveFile?";
	   try {
	       String pageurl=servlet + "command=upload&dest="+dest+"&src="+source+"&rf_ior=" + orb.object_to_string(applet.getRemoteFile());
	       System.out.println(pageurl); 
	       URL docURL= new URL(pageurl);
	       applet.getAppletContext().showDocument(docURL,"GatewayHTML");
	   } catch (MalformedURLException me) {System.out.println(me);}
       }
       
       public void download(String dest, String source){
	   System.out.println("download, dest=" + dest + ", source=" + source);
	   String servlet = "http://" + applet.jhost + ":" + applet.jport + "/servlets/GWMoveFile?";
	   try {
	       String pageurl=servlet + "command=download&dest="+dest+"&src="+source+"&rf_ior=" + orb.object_to_string(applet.getRemoteFile());
	       System.out.println(pageurl); 
	       URL docURL= new URL(pageurl);
	       applet.getAppletContext().showDocument(docURL,"GatewayHTML");
	   } catch (MalformedURLException me) {System.out.println(me);}
       }

       public void view(String full_name, String file_name) {
	   URL docURL = null;
	   String destFile="/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/tmp/"+file_name; 
	   org.omg.CORBA.StringHolder dest = new org.omg.CORBA.StringHolder(destFile);
	   FileBrowser.getFileBrowser().copyFile(full_name, dest);
	   int index = dest.value.lastIndexOf('/');
	   if(index != -1)
	       file_name = dest.value.substring(index + 1);
	   else file_name = dest.value;
	   System.out.println("fileCopied to " + destFile);
	   try {
	       String pageurl= "http://" + applet.jhost + ":" + applet.jport + "/tmp/"+file_name;
	       System.out.println("url to show is: " + pageurl);
	       docURL = new URL(pageurl);
	   } catch (MalformedURLException me) {System.out.println(me);}
	   applet.getAppletContext().showDocument(docURL,"GatewayHTML");
       }
   }






