package EDU.syr.npac.Gateway;

   import org.omg.CORBA.*;
   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import javax.swing.*; 
   import java.net.*;
   import EDU.syr.npac.frontend.*;
   import WebFlow.*;
   import WebFlow.event.*;
   import WebFlow.xml.*;
   import WebFlow.gscript.*;
   import WebFlow.hashtable.*;
   import WebFlow.RemoteFile.*;
   import WebFlow.submitJob.*; 
   import WebFlow.FileBrowser.*;
   import WebFlow.ccm.*; 
   import java.io.*;
   import java.net.*;
   import java.util.*;

   public class gw extends JApplet
   {
      private int appCount_ = 0;
      private ORB orb;

     // master IOR stuff
      public String relMasterIOR;  //where master IOR is stored
      public String IorUrl;        //URL of master IOR
      public String IOR;
      public String jhost;
      public String jport;

     // contexts 
      private WebFlowContext ws = null;
      public WebFlowContext uc= null;
      private WebFlowContext ProjectContext = null;
      private WebFlowContext SessionContext = null;
      private WebFlowContext ApplContext = null;
      private String ProjectName, SessionName, ApplicationName;
      private String ProjContextName, SessionContextName, ApplContextName;
      public String UserName;

     //for manipulations with contexts (will be moved to server side)
      private Vector ProjContextList, ProjContextNames;
      private Vector SessionContextList, SessionContextNames;

     // context data
      private ContextData UserContextData;
      private ContextData ProjectContextData, SessionContextData;
      private ContextData ApplicationContextData;
      private String curDir;      // directory to save context data
      public Date currentDate;    // time stamp
      public long time;           // as above, serialized 

     // modules  
      private org.omg.CORBA.Object oxml,ohash,og,os,orf,osc,ofb; 
      private String ContextDataIOR, gScriptIOR, XmlServerIOR;
      private String submitJobIOR, RemoteFileIOR, SaveContextIOR;
      private String FileBrowserIOR;
      private gScript gscript;
      private XmlServer parser;
      private submitJob submit;
      private RemoteFile remotefile;
      private SaveContext saveContext;
      private FileBrowser filebrowser;

     // for servlet output processing
      private Hashtable HTMLform;
      private int FormLength;
      private String[] FormElementNames;
      private String[] FormElementValues;
      private int currentPage;    // servlet's ID
      private String pageurl;     // String: URL of servlet to be called
      private URL docURL;         // above converted to java object URL
      public AppletContext ac;    // used to call the servlet
      private String appl;        // application descriptor (XML)  
      private String inputFile;   // file name selected by the user 

     // control applet GUI (ignore for now)
      private CardLayout card = new CardLayout();
      public JPanel  cP;
      private navigator nv;
      public String Display;  

     // for multihost case (ignore for now) 
      private JTextField hostLabel; 
      private String hostname,rootname;
      public static String[] hostnames;       
      public String[] fileRoot;
      public boolean[] connectedHosts;
      public TabbedPane[] cards;
      private Hashtable Slaves;
      private Hashtable ht;
      private String ServletDir="http://osprey4.npac.syr.edu:8001/servlets/";
      private String DDir = "/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/DESCRIPTORS/";

     // misc
      private int n;
      private boolean debug=true;
      private boolean isOK;
 
      public void init() {

      Slaves = new Hashtable();
      ProjContextNames = new Vector();
      SessionContextNames = new Vector();

      n=4;
      hostnames = new String[n];
      hostnames[0] = "osprey2.npac.syr.edu";
      hostnames[1] = "osprey3.npac.syr.edu";
      hostnames[2] = "osprey4.npac.syr.edu";
      hostnames[3] = "osprey7.npac.syr.edu";

      fileRoot = new String[n];
      fileRoot[0]="/tmp";
      fileRoot[1]="/tmp";
      fileRoot[2]="/npac/home/webflow/QSData";
      fileRoot[3]="/tmp";

      HTMLform = new Hashtable(); 

      ht = new Hashtable();
        for (int i=0; i<4; i++) {
        ht.put(gw.hostnames[i],new Integer(i));
      } 



      connectedHosts = new boolean[n];
       
      String UC = getParameter("userContext");
      if(UC == null) {
         System.err.println("user name not defined.");
         stop();
      }
      else {
         UserName = UC;
         System.err.println("user name = "+UserName);
      } 

      jhost = getParameter("jhost");
      jport = getParameter("jport"); 
      relMasterIOR = "/"+getParameter("relMasterIOR");

      rootname = getParameter("host");
      hostname = rootname;

      Display = getParameter("DISPLAY");
      System.out.println("Display set to: "+Display);

      IorUrl = "http://"+jhost+":"+jport+relMasterIOR;
      System.out.println("IorUrl = "+IorUrl); 

      for(int i=0; i<n; i++) {
        if(hostnames[i].equals(rootname)) {
           connectedHosts[i]=true;
	}
        else {
           connectedHosts[i]=false;
	}
      }

      orb = ORB.init(this, new java.util.Properties());
      setUserContext(IorUrl,UC);

      org.omg.CORBA.Object occm = uc.addNewModule("ccm");
      ccm ccm101 = ccmHelper.narrow(occm);

      /* add XML server */
      oxml = uc.addNewModule("XmlServer");
      XmlServerIOR=orb.object_to_string(oxml);
      parser = XmlServerHelper.narrow(oxml);
      parser.test();
      /* add UserHashtable */
      ohash = uc.addNewModule("ContextData");
      ContextDataIOR = orb.object_to_string(ohash);
      UserContextData = ContextDataHelper.narrow(ohash);
      UserContextData.test(); 
      /* add SaveContext */
      osc = uc.addNewModule("SaveContext");
      SaveContextIOR = orb.object_to_string(osc);
      saveContext = SaveContextHelper.narrow(osc);
      saveContext.test(); 
      /* add GaussianScript */
      og = uc.addNewModule("gScript");
      gScriptIOR = orb.object_to_string(og);
      gscript = gScriptHelper.narrow(og);
      gscript.test(); 
      /* add submitJob */
      os = uc.addNewModule("submitJob");
      submitJobIOR = orb.object_to_string(os);
      submit = submitJobHelper.narrow(os);
      submit.test(); 
      /* add remotefile */
      orf = uc.addNewModule("RemoteFile");
      RemoteFileIOR = orb.object_to_string(orf);
      remotefile = RemoteFileHelper.narrow(orf);
      remotefile.test(); 
      /* add FileBrowser */
      ofb = uc.addNewModule("FileBrowser");
      RemoteFileIOR = orb.object_to_string(ofb);
      filebrowser = FileBrowserHelper.narrow(ofb);
      filebrowser.test(); 
      System.out.println("All the modules successfuly created");
      
      String udir=DDir+"USER/"+UserName;
      setContextData(uc,"Directory",udir);

      nv = new navigator(this,UserName);
      nv.setSize(400,150);

      System.out.println("navigator created"); 
      ac=getAppletContext();

      java.awt.Container c = getContentPane();
      getContentPane().setLayout(new BorderLayout());

      JPanel upperPanel = new JPanel();
      upperPanel.setLayout(new BorderLayout());

      JPanel bP = new JPanel();
      bP.setLayout(new GridLayout(2,2));
      JButton b1 = new JButton("Home");
      JButton b2 = new JButton("Navigator");
      JButton b3 = new JButton("Logout");
      JButton b4 = new JButton("About");

      bP.add(b1);
      bP.add(b2);
      bP.add(b3);
      bP.add(b4);

      hostLabel= new JTextField(hostname,25);
      hostLabel.setEditable(false);

      cP = new JPanel();
      cP.setLayout(card);

      System.out.println("create TabbedPane...");
     cards = new TabbedPane[n];

      System.out.println("TabbedPane created");

      for(int i=0; i<n; i++) { 
         cards[i]=null;
      } 

       System.out.println("add cards");
      addCard(rootname);      
       System.out.println("show card"); 
      showCard(rootname);

       System.out.println("make action listener");

      ActionListener Blistener = new ActionListener() {
      public void actionPerformed(ActionEvent e) {
          String what= e.getActionCommand().toString();
          if(what.equals("Navigator")) {
          nv.show();           
	  }
	  if(what.equals("Logout")) {
	    try {
              uc.removeMyself();
	    }
            catch(org.omg.CORBA.COMM_FAILURE exception) {
             System.out.println("user context deleted");
            pageurl="http://osprey4.npac.syr.edu:8001/PORTAL/Portal.html";
            try {
            docURL = new URL(pageurl);
            ac.showDocument(docURL);
            } catch (Exception ee) {System.out.println("Really? "+e);}
	    }
	  }
          if(what.equals("Home"))  {
               pageurl="http://osprey4.npac.syr.edu:8001/servlets/UserPage?userContext="+UserName;
          try { 
              docURL=new URL(pageurl);
              showPage(docURL);
            } catch (Exception mo) {System.out.println(mo);}
	  }
	  if(what.equals("About")) {
            pageurl="http://www.npac.syr.edu/users/haupt/WebFlow/";
            try { 
              docURL=new URL(pageurl);
              showPage(docURL);
            } catch (MalformedURLException me) {System.out.println(me);}

	  }
      }
      };

       System.out.println("add action listener");
      b1.addActionListener(Blistener);
      b2.addActionListener(Blistener);
      b3.addActionListener(Blistener);
      b4.addActionListener(Blistener);

        System.out.println("add panels");

      upperPanel.add(BorderLayout.CENTER,bP);
      upperPanel.add(BorderLayout.SOUTH,hostLabel);
      c.add(BorderLayout.NORTH,upperPanel);
      c.add(BorderLayout.CENTER,cP);
      System.out.println("init completed");

      }
 


     public void showCard(String what){
      card.show(cP,what);
     }

     public void addCard(String host){
	 try {
      int idx=getHostIndex(host);
      cards[idx] = new TabbedPane(this,UserName,fileRoot[idx],hostnames[idx]);
      cP.add(hostnames[idx],cards[idx]);
	 } catch (Exception e) {
              System.out.println(e+" while creating TabbedPane");
         }
     }

       public ORB getORB() {
         return orb;
       }


     public String getUserName() {
       return UserName;

     }
     public void setUserName(String UC) {
       UserName=UC;
     }

    public void showPage(URL docURL) {
    ac.showDocument(docURL,"GatewayHTML");
   }

     public void showNavigator(){
      nv.show();
	}

     public void setHostname(String host) {
       hostname = host;
       hostLabel.setText(host);
     }

     public String getHostname() {
       return hostname;
     }  

     public void setRootname(String host) {
       rootname = host;
     }

     public String getRootname() {
       return rootname;
     }  

     public void setConnectedHost(String host) {
       for (int i=0; i<n; i++) {
         if(hostnames[i].equals(host)) connectedHosts[i]=true;
       }
     }
    
    public WebFlowContext getUserContext() {
       return uc;
     }

     public void setSlaves(String host, WebFlowContext wc){
       Slaves.put(host,wc);
     }

     public WebFlowContext getSlaves(String host){
       WebFlowContext wc=(WebFlowContext)Slaves.get(host);
      return wc;
     }

     public int getHostIndex(String host){
     int idx = ((Integer)ht.get(host)).intValue();
     return idx;
   }


     public void selectContexts(String contextName) {
       System.out.println("selectContexts: "+contextName); 
       if(contextName.equals("Project")) {
          listContexts(uc,".PC", "project");
       }
       if(contextName.equals("Session")) {
          listContexts(ProjectContext,".SC", "session");
       } 
       if(contextName.equals("Application")) {
          listContexts(SessionContext,".AC", "application");
       } 
     }



     public void listContexts(WebFlowContext root, String suffix,
                              String name) {
       Vector ContextList = makeListOfContexts(root,suffix);     
       Enumeration l = ContextList.elements();
       int numberOfElements = ContextList.size();

       pageurl = ServletDir;
       int k=0;

       System.out.println(suffix);

       if(suffix.equals(".SC")) {
          ProjectName = ProjectContextData.getParam("Project");
       }
       if(suffix.equals(".AC")) {
          ProjectName = SessionContextData.getParam("Project");
          SessionName = SessionContextData.getParam("Session");
       }

       if(numberOfElements>0) {
	 if(suffix.equals(".AC")) {
             pageurl = ServletDir+"PSE"+name+"list?Project="+ProjectName;
             pageurl += "&Session="+SessionName;
             pageurl += "&n="+numberOfElements;
	 }
         else {
	   if(suffix.equals(".SC")) {
             pageurl = ServletDir+"PSE"+name+"list?Project="+ProjectName;
             pageurl += "&n="+numberOfElements;
	   }
           else {  
             pageurl = ServletDir+"PSE"+name+"list";
             pageurl += "?n="+numberOfElements;
	   }
	 }

          while (l.hasMoreElements()){
           k++;
           WebFlowContext c = (WebFlowContext)l.nextElement();
           pageurl += "&c"+k+"="+c.getObjectID();
           if(suffix.equals(".SC")) {
             ContextData cd = findContextData(c);
             pageurl += "&s"+k+"="+cd.getParam("Time");
             pageurl += "&q"+k+"="+cd.getParam("LastTime");
	   }
	  }
       }

       else {

	 if(suffix.equals(".AC")) {
             pageurl = ServletDir+"PSE"+name+"list?Project="+ProjectName;
             pageurl += "&Session="+SessionName;
             pageurl += "&n=0";
	 }
         else {
	   if(suffix.equals(".SC")) {
               pageurl = ServletDir+"PSE"+name+"list?Project="+ProjectName;
               pageurl += "&n=0";
	   }
           else {  
               pageurl = ServletDir+"PSE"+name+"list";
               pageurl += "?n=0";
	   }
	 }
       }
       System.out.println("listContexts: "+pageurl);
       callServlet(pageurl);
     }


     /* there is ContextManager method that returns Array of those */
     public Vector makeListOfContexts(WebFlowContext root, String suffix) {
       // all contexts are returned, possibly of different kind!
      if(debug) System.out.println("suffix="+suffix);
      Vector list = new Vector();
      org.omg.CORBA.Object[] ContextObjs=root.toArray();
     if(debug) System.out.println("number of objects === "+ContextObjs.length);
      for(int i=0; i<ContextObjs.length;i++) {
         WebFlow.BeanContextChild Something=null;
         Something=BeanContextChildHelper.narrow(ContextObjs[i]);
         String ObjectName=Something.getObjectID();
         System.out.println("Name: "+ObjectName);
         if(ObjectName.endsWith(suffix)) {
           WebFlowContext c = WebFlowContextHelper.narrow(ContextObjs[i]);
           list.addElement(c);
	 }
      } 
      return list; 
     }

     public String[] makeTSortedList(WebFlowContext root) {
         Vector AllContexts = new Vector();
         Vector Times = new Vector(); 
         Vector PContexts = makeListOfContexts(root,".PC");
         Enumeration PCenum = PContexts.elements();
         while(PCenum.hasMoreElements()) {
            WebFlowContext wfc = (WebFlowContext)PCenum.nextElement();
            Vector SContexts = makeListOfContexts(wfc,".SC"); 
            int n = SContexts.size();
            for(int i=0; i<n; i++) {
              WebFlowContext wfc1 = (WebFlowContext)SContexts.elementAt(i);
              String key = wfc1.getObjectID()+"/ContextData";
              org.omg.CORBA.Object cobj = uc.getKeyedChild(key); 
              ContextData cd=null; 
              if(cobj != null){
                 cd = ContextDataHelper.narrow(cobj); 
	      }
              else {
              System.out.println("contextData not found!");
	      }
	    Times.addElement(cd.getParam("Time"));
            AllContexts.addElement(cd.getParam("Session"));
	    }
	 }
        String[] result = Tsort(AllContexts,Times);
        return result;    
     }

     public String[] Tsort(Vector values, Vector keys){
        int n = values.size();
        String[] result = new String[n];
        long[] time = new long[n];
        for(int i=0;i<n;i++) { result[i] = (String)values.elementAt(i);}
        for(int i=0;i<n;i++) { 
              time[i] = ((Long)values.elementAt(i)).longValue();
	}
        for(int i=n-1;i>-1;i--){
	  for(int j=0;j<i;j++) {
            if(time[j]>time[j+1]) {
               long A = time[j];
               String B = result[j];
               time[j]=time[j+1];
               result[j]=result[j+1];
               time[j+1]=A;
               result[j+1]=B;
	    }
	  }
	}
        return result;
     }

     public void setFormLength() {
      System.out.println("setFormLength: parameter needed!");
     }

     public void setFormLength(String nstring) {
      System.out.println("start setFormLenghth");
     int n=0;
       try {
         n=Integer.parseInt(nstring); 
	   }
       catch (Exception e) { System.out.println(e);} 
      FormLength = n;
      FormElementNames = new String[n];  
      FormElementValues = new String[n];
      System.out.println("(String) new form of length "+n);
     }

     public void addFormElement(int i, String name, String value) {
       FormElementNames[i]=name;
       FormElementValues[i]=value;
       System.out.println("add element: "+name+" = "+value);

       HTMLform.put(name,value);

       if(name.equals("page")) {
	 try {
            currentPage = Integer.parseInt(value);
	 }
	 catch (NumberFormatException nfe) {System.out.println(nfe);}
       }
     }


     public void forwardLink() {
      System.out.println("forwardLink called");
     }

     public void forwardLink(String page) {
      int i=0; 
       try {
         i = Integer.parseInt(page);
       } catch (Exception e) {System.out.println(e);} 
      currentPage = i;
      FormLength=0;
      System.out.println("?? process page "+currentPage); 
      forwardForm();
     }

     public void forwardForm() {
      System.out.println("forwardForm: #params = "+FormLength);
      
      for (int i=0; i<FormLength; i++) {
          System.out.println(FormElementNames[i]+" = "+FormElementValues[i]);
      }
      
      switch(currentPage) {

      case 0:
	  // you came from New Project button
          pageurl=ServletDir+"PSEnewProject";
          callServlet(pageurl);
          break;

      case 1:
	{
          if(FormLength>0) createNewProject();
          else {
            if(currentProject()) { 
              pageurl = ServletDir+"PSEnewSession?Project="+ProjectName;
	    }
            callServlet(pageurl); 
	  }
          break;
	}

      case 11:
	{
          //you came from PSEnewSession servlet
	  // adds a new session to the ProjectContext  
          if(debug) System.out.println("start processing page 11");

          if(FormLength>0) createNewSession();
          else {
     
          // you continue or came here from Select Session button 
          // now prepare for the next form
          // call servlet that asks for application(s)
          // servlet name is PSEaddApplication 
          // parameters: ProjectName, SessionName
          // eventually it will be replaced by PSE

          if(currentProject()) {
             System.out.println("currentProject OK");
	    if(currentSession()) {
             System.out.println("currentSession OK");
              if(sessionOfProject()) {
             System.out.println("sessionOfProject OK");
                  ProjectName=SessionContextData.getParam("Project");
                  SessionName=SessionContextData.getParam("Session"); 
	      //pageurl=ServletDir+"PSEapplicationlist?Project="+ProjectName;
	      //pageurl+="&Session="+SessionName;
             listContexts(SessionContext,".AC", "application");
             System.out.println("11 OK");

	      }
	    }
	  }
	  //callServlet(pageurl); 
	  }
         break; 
	}

      case 2:    
	{
	  // adds an new application context to the session context
          // returns select input page        

	 if(FormLength>0) createNewApplication();
         else {
         if(currentProject()) {
           if(currentSession()) {
	     if(sessionOfProject()) {
               if(currentApplication()) {
                 ProjectName=ApplicationContextData.getParam("Project");
                 SessionName=ApplicationContextData.getParam("Session"); 
                 ApplicationName = ApplicationContextData.getParam("ApplicationName");
                 pageurl=ServletDir+"PSEinput?appl="+ApplicationName;
                 pageurl+="&Project="+ProjectName; 
                 pageurl+="&Session="+SessionName;
	       } 
	     }
	   }
	 }
	 }
         callServlet(pageurl);
         break;
	}             
      case 12:
	{
          // process select host page
          // returns select job page

         String userDir = DDir+UserName+"/";
         inputFile = "";

         String machine="";
	 if(FormLength>0) {
           machine =  (String)HTMLform.get("target");
           ApplicationContextData.setParam("target",machine);
	 }
	  else {
           if(ApplicationContextData.containsKey("target")) {
                machine = ApplicationContextData.getParam("target");
                System.out.println(machine);
	   }
	   else {
                System.out.println("Case 12: no target key");
                machine = "";
	   }
	  }

         if(ApplicationContextData.containsKey("Code")) {
           ApplicationName=ApplicationContextData.getParam("Code");
	 }
         else System.out.println("Case 12: no Code Key"); 


         if(ApplicationContextData.containsKey("InputFile")) {
           inputFile=ApplicationContextData.getParam("InputFile");
	 }
         else System.out.println("Case 12: no inputFile Key"); 

         if(ApplicationContextData.containsKey("ApplDesc")) {
                 ApplicationName = ApplicationContextData.getParam("ApplDesc");
         }
         else { 
                 ApplicationName="";
                 System.out.println("Case 12: no ApplDesc key");
	 }
               
	 // decide where to write the actual application descriptor


	 // invent filename for Abstract Task Descriptor
         // later on put it to /UserName/ProjectName/SessionName.txt  
          String ATDpath=DDir+"USER/"+UserName+"/"; 
          String ADTfile = ATDpath+"whatever.txt";


         if(ApplicationName.length()>0) {
            if(machine.length()>0) { 
              pageurl = ServletDir+"PSEaTask?appl="+ApplicationName;
              pageurl += "&target="+machine;
              pageurl += "&inputFile="+inputFile;
              //pageurl += "&userDir="+userDir;
	      //  pageurl += "&xmlIOR="+XmlServerIOR;
              pageurl += "&Project="+ProjectName;  
              pageurl += "&Session="+SessionName;
              pageurl += "&File="+ADTfile;   
	    }
            else {
              pageurl = ServletDir+"PSEinputError?appl="+ApplicationName;
	    }
	 }
         else {
              pageurl = ServletDir+"PSEcodeError";
	 } 

         callServlet(pageurl);
         break; 
	}          

      case 3:
	{
          // process select input
          // returns submit job page

       if(FormLength >0) {
         inputFile = (String)HTMLform.get("InputFile");
         setContextData(ApplContext,"InputFile",inputFile); 
       }
       else { 
         appl= getContextData(ApplContext,"ApplDesc");
         ProjectName = getContextData(ApplContext,"Project");
         SessionName = getContextData(ApplContext,"Session");
         inputFile   = getContextData(ApplContext,"InputFile"); 
       }
	 /*  
         if(ApplicationContextData.containsKey("ApplDesc")) {
            appl=ApplicationContextData.getParam("ApplDesc");
	 }
         else System.out.println("Case 3: no ApplDesc Key"); 
         
         if(ApplicationContextData.containsKey("Project")) {
           ProjectName=ApplicationContextData.getParam("Project");
	 }
         else System.out.println("Case 3: no Project Key"); 

         if(ApplicationContextData.containsKey("Session")) {
           SessionName=ApplicationContextData.getParam("Session");
	 }
         else System.out.println("Case 3: no Session Key"); 

         if(ApplicationContextData.containsKey("InputFile")) {
           inputFile=ApplicationContextData.getParam("InputFile");
	 }
         else System.out.println("Case 3: no inputFile Key"); 
	 */

         pageurl= ServletDir+"PSEcode?appl="+appl+"&xmlIOR="+XmlServerIOR;
         pageurl += "&Project="+ProjectName;
         pageurl += "&Session="+SessionName;
         pageurl += "&inputFile="+inputFile;
         callServlet(pageurl);
         break;
	}          
      case 4:
	{
	  // you came from aTask
          // that servlet does not produce any data
          // it writes ATD
          // take everything from Application and Session ContextData
          // submit

          //process ATD 
          // to be done by ATDprocessor module to be written by Wendy
          // at this time we know that the selected application is 
          // to ne executed

          //ATD is supposed to have a pointer to the actual application
          //descriptor (AD). Filtering module is to be written by Rajshree.

          //So for the time being I assume that for each target I have my
	  //my AD. It is called ApplicationName-host. 

	  //Until the module is available, I allow one input
          //and one output file.

          //String target = ApplicationContextData.getParam("target");
          String target = getContextData(ApplContext,"target");
          String Application = getContextData(ApplContext,"Application");
          String ADpath=DDir+"USER/"+UserName+"/"; 
          String ADfile = ADpath+ApplicationName+"-"+target+".xml";
          System.out.println(ADfile); 

          if(parser.instantiateParser(ADfile)) { 
	    // src=parser.getSource();
            //dst=parser.getInFile();
            //transferFile(src,dest); 
	      
	      /*
		Commented by Alexey. Failed to compile 10/25/99 at 16:33
		parser.getCmdLine(target,"local");
	      */
            //src=parser.getOutFile();
            //dest=parser.getDest();              
            //transferFile(src,dest);
            pageurl=ServletDir+"Success";
	  }
          else {
            pageurl=ServletDir+"Error?what=submit+job+failed&where=case+4";
	  }  
 
          callServlet(pageurl);
          break;
	}
	case 21: 
	  {
            // you came from PSEprojectlist (select Project button)

           String action = (String)HTMLform.get("action"); 

            if(action.equals("new")) {
	         //ask the user for the name of the new project first
                 pageurl=ServletDir+"PSEnewProject";
                 callServlet(pageurl);
	    }
            if(action.equals("delete")) {
                 ProjectContext = selectContext(uc,".PC","projectlist");
                 curDir=getContextData(ProjectContext,"Directory");
                 if(remotefile.rmdir(curDir))
                   System.out.println("project deleted");
                 else {
                   System.out.println("deletion failed!");
		 } 
                 ProjectContext.removeMyself();
                 listContexts(uc,".PC", "project");
	    } 
            if(action.equals("archive")) archiveProject();
            if(action.equals("select")) {
                ProjectContext = selectContext(uc,".PC","projectlist");
                ProjectContextData = findContextData(ProjectContext); 
                // set global variables 
                ProjectName = ProjectContextData.getParam("Project"); 
                UserContextData.setParam("Project",ProjectName); 
                // list sessions added to the project
                listContexts(ProjectContext,".SC", "session");
	    }

	   break; 
	  }  
	case 22: 
	  {
            // you came from PSEsessionlist (select Session button)

           String action = (String)HTMLform.get("action"); 

            if(action.equals("new")) {
	         //ask the user for the name of the new session first
               if(currentProject()) { 
                  pageurl = ServletDir+"PSEnewSession?Project="+ProjectName;
	       }
               callServlet(pageurl); 
	    }
            if(action.equals("delete")) {  
                 SessionContext = selectContext(ProjectContext,".SC",
                                               "sessionlist");
                 curDir=getContextData(SessionContext,"Directory");
                 remotefile.rmdir(curDir);
                 SessionContext.removeMyself();
                 listContexts(ProjectContext,".SC", "session");
	    }
            if(action.equals("archive")) archiveSession();
            if(action.equals("select")) {
                SessionContext = selectContext(ProjectContext,".SC",
                                               "sessionlist");
                SessionContextData = findContextData(SessionContext); 
                // set global variables 
                ProjectName = SessionContextData.getParam("Project"); 
                SessionName = SessionContextData.getParam("Session"); 
                // list applications added to the session
                listContexts(SessionContext,".AC", "application");
	    }

	   break; 
	  }  

      case 50:
	{
	  // get information about application to be submitted
	  if(FormLength >0 ) {
           String commandLine=(String)HTMLform.get("commandLine");
           String inFile=(String)HTMLform.get("inFile");
           String source=(String)HTMLform.get("source"); 
           String outFile=(String)HTMLform.get("outFile");
           String dest=(String)HTMLform.get("dest"); 
           String scriptSource=(String)HTMLform.get("scriptSource");
           String scriptDest=(String)HTMLform.get("scriptDest");
           /* what should be done now:
            1.  rcp scriptSource to scriptDest
            2.  rcp source to inFile
            3.  rsh commandLine
            4.  wait till completed
            5.  rcp outFile to 
	    */   
	  }
         break;
	} 

      default: 
	{ System.out.println("Oops, unknown case "+currentPage);} 
      } 
      
      System.out.println("--- end of forwardForm");
     }


     public void callServlet(String pageurl) {

	  try {
            System.out.println(pageurl);
            docURL = new URL(pageurl);
            ac.showDocument(docURL, "GatewayHTML");
          } catch (Exception ee) {System.out.println("Really? "+ee);}
     }

    public void setUserContext(String IorUrl, String UserName) {
      uc=null;

      /* connect to the master */

      System.out.println(IorUrl);
      try {
      java.net.URL url = new java.net.URL(IorUrl);       
      InputStream istream;
      String ref = "";

      System.out.println("open stream");   
      try {
       istream = url.openStream();
       BufferedReader in = new BufferedReader(new InputStreamReader(istream));
       ref = in.readLine();
       istream.close();
  
        
      System.out.println("read:"+ref);   
       try { 
        System.out.println("obj2str"); 
       org.omg.CORBA.Object MasterObj=orb.string_to_object(ref);
        if(MasterObj == null) {
          System.out.println("Master is null ??????");
        }
        else {
          System.out.println("MasterObj is OK");
        }
         
	 ws = WebFlowContextHelper.narrow(MasterObj);
        if(MasterObj == null) System.out.println("Oops: MasterObj is null!");
        System.out.println("Master narrowed");
     

       }catch(Exception e) {
         System.out.println("CORBA problem: "+e);
       }
      }
       catch(IOException e) { 
         System.out.println("stream problem: "+e);
      }
      }
      catch (Exception urle) {System.out.println("URL problem"+urle);}


      /* find the user context */

      org.omg.CORBA.Object[] SlaveServers = ws.toArray();
      for(int i=0; i<SlaveServers.length; i++) {
          System.out.println(i);
          WebFlow.BeanContextChild Something=null;
          Something =BeanContextChildHelper.narrow(SlaveServers[i]);
             if(Something.isWFServer()) {
               System.out.println("is a WebServer");            
               WebFlowContext sl=WebFlowContextHelper.narrow(SlaveServers[i]);
               String SlaveName = sl.getObjectID();
               if(SlaveName.indexOf(UserName)>-1) {
                     uc=sl;
                     setSlaves(rootname,uc);
	       }
              System.out.println("endif");
	     }
      }

      if(uc._non_existent()) System.out.println("Oops: cannot connect to the user context !!!!");
      System.out.println("setUserContext completed");
      IOR=orb.object_to_string(uc);

      /* now check if any slaves are running */
       org.omg.CORBA.Object[] SlaveServers1 = uc.toArray();
       if(SlaveServers1.length>0) {
         for(int i=0; i<SlaveServers1.length; i++){
           System.out.println(i);
          WebFlow.BeanContextChild Something=null;
          Something =BeanContextChildHelper.narrow(SlaveServers1[i]);
              System.out.println(Something.getObjectID()); 
             if(Something.isWFServer()) {  
               System.out.println("is a WeBFlow server");           
              WebFlowContext bcc=WebFlowContextHelper.narrow(SlaveServers1[i]);
              String SlaveName = bcc.getObjectID();

                for(int j=0; j<n; j++) {
	          if(SlaveName.indexOf(UserName+"./"+hostnames[j])>-1) {
                     WebFlowContext sl = WebFlowContextHelper.narrow(bcc);
                     setConnectedHost(hostnames[j]);
                     setSlaves(hostnames[j],sl);
	          }
		}
               System.out.println("for done");  
	     }
           System.out.println("isWFServer done");  
	 }
         System.out.println("for over childs done");
       }
    System.out.println("setUserContext completed");
    }


     // -------- utilities ---------------------------------------

          public String removeSpaces(String name){ 
          // if name contains spaces replace them by _
          String oldName = name; 
          while(oldName.indexOf(' ')>-1) {
            StringBuffer sb = new StringBuffer(oldName);
            int idx1=oldName.indexOf(' ');
            sb.setCharAt(idx1,'_');
            oldName=new String(sb); 
	   }
           String newName=oldName;
           return newName; 
          } 

          public String setShortName(String ContextName){
          // format ContextName for display
           String ShortName = ContextName;
           int idx=ShortName.lastIndexOf("/");
           ShortName = ShortName.substring(idx+1);
           return ShortName; 
	  }

      public boolean currentProject(){
          // what is the current project?
	  // return false if no current project
	  // WARNING: it operates on global variables 

          boolean x = false;   

          if(ProjectContextData==null) { 
                pageurl = ServletDir+"Error?where=currentProject";
                pageurl += "&what=noProjContextData";
          }
          else {
                ProjectName=ProjectContextData.getParam("Project");
                x=true; 
	  }      
        return x;
      }

      public boolean currentSession(){
          // what is the current session?
	  // return false if no current session
	  // WARNING: it operates on global variables 

          boolean x = false;   
          if(SessionContextData==null) { 
               pageurl = ServletDir+"Error?where=currentSession";
               pageurl += "&what=no+SessionContextData";
          }
          else {
               SessionName=SessionContextData.getParam("Session");
               x=true; 
	  }   
        return x;
      }

      public boolean sessionOfProject(){
          // is the SessionContextData consistent with the ProjectContextData?
	  // returns false if not consistent
	  // WARNING: it operates on global variables 

          boolean x = false;
          if(SessionContextData==null) {
             pageurl = ServletDir+"Error?where=sessionOfProject";
             pageurl += "&what=no+SessionContextData";
	  }
          else {
             String sname=SessionContextData.getParam("Session"); 
             if(SessionName.equals(sname)) {
               String pname=SessionContextData.getParam("Project");
               if(pname.equals(ProjectName)) {
                  x=true; 
	       }
               else {     
                  pageurl = ServletDir+"Error?where=sessionOfProject";
                  pageurl += "&what=wrong+project+name";
                  System.out.println("ProjectName="+ProjectName);
                  System.out.println("pname="+pname);
	       }
	     }
             else {
                pageurl = ServletDir+"Error?where=sessionOfProject";
                pageurl += "&what=wrong+session+context+name";
                System.out.println("SessionName "+SessionName);
                System.out.println("sname "+sname);
	     } 
	  }
          return x;
      }
      public boolean currentApplication(){
          // what is the current application?
	  // return false if no current application
	  // WARNING: it operates on global variables 

          boolean x = false; 
     
          if(ApplicationName!=null | ApplicationName.length()>0) {
            if(ApplicationContextData==null) {
             pageurl = ServletDir+"Error?where=currentApplication";
             pageurl += "&what=no+ApplicationContextData";
	    }
            else {   
	     if(ApplicationContextData.containsKey("Code")) {
               String Code=ApplicationContextData.getParam("Code");
                 if(Code.equals(ApplicationName)) { 
                   x=true; 
                 }
                 else {
                   pageurl = ServletDir+"Error?where=currentApplication";
                   pageurl += "&what=wrong+application+name";
                   System.out.println(Code+" "+ApplicationName);
		 }
	     }      
             else {
	       // no current application        
                pageurl = ServletDir+"PSEapplicationError";
                pageurl += "?Session="+SessionName;
                System.out.println("no Code entry in hashtable");  
	     }
	    }
	  }
          else {
	       // no current application        
                pageurl = ServletDir+"PSEapplicationError";
                pageurl += "?Session="+SessionName;
                System.out.println("application name not set");  
	  }
        return x;
      }



      public WebFlowContext selectContext(WebFlowContext root, String suffix,
                                          String name){
    
	   /* select context specified in HTMLform */
           Vector ContextList = makeListOfContexts(root,suffix);     
           Enumeration l = ContextList.elements();
           int numberOfElements = ContextList.size();

           WebFlowContext selectedContext = null; 
           
           if(numberOfElements>0) {
              while (l.hasMoreElements()){
                WebFlowContext c = (WebFlowContext)l.nextElement();
                String contextName = c.getObjectID();
                if(((String)HTMLform.get(contextName)).equals("true")) {
                selectedContext = c;
	        }
	      }
	   }
           else {
               pageurl = ServletDir+"PSE"+name+"Error";  
               callServlet(pageurl);
	   }
	   if(selectedContext==null) {
              pageurl = ServletDir+"PSE"+name+"Error1";
              callServlet(pageurl);
	   }
         return selectedContext;  
      }             

       /* candidate for context manager */
       public ContextData findContextData(WebFlowContext wfc) {
          ContextData wfcContextData=null;

          String ContextDataName = wfc.getObjectID()+"/ContextData";
          org.omg.CORBA.Object o = wfc.getKeyedChild(ContextDataName);
          if(o != null) {
          wfcContextData = ContextDataHelper.narrow(o); 
	  } else {System.out.println("Context data not found!");}

     
	  if(wfcContextData==null) {
            System.out.println("Context data not found!");
	  }
        return wfcContextData;
       }
 

     public void createNewProject() {

          ProjContextName = (String)HTMLform.get("ProjectContextName");

          ProjContextName=removeSpaces(ProjContextName);
          ProjectName=setShortName(ProjContextName);

          /* create directory for this project */  
          System.out.println("create directory:");
          curDir = DDir+"USER/"+UserName+"/"+ProjectName;
          System.out.println(curDir); 
          if(remotefile.mkdir(curDir)){

             System.out.println(ProjContextName);
          // format ProjContextName for display
             ProjectName = ProjContextName;
             int idx=ProjectName.lastIndexOf("/");
             ProjectName = ProjectName.substring(idx+1);

          System.out.println(ProjectName);
	    // make it easier to identify an ProjectContext
             ProjContextName += ".PC";


          // ???? set the project as the current one
            setContextData(uc,"Project",ProjContextName);

          // create a new ProjectContext
            try {
            ProjectContext=WebFlowContextHelper
               .narrow(uc.addNewContext(ProjContextName)); 

          // add ContextData module to the newly created context
            ProjectContextData = 
            ContextDataHelper.narrow(ProjectContext.addNewModule("ContextData"));
          //  store Context name in the ContextData 
          //  ProjectName is fully qualified context name +.PC
          //  Project is what the user entered without spaces  

            setContextData(ProjectContext,"ProjectName",ProjContextName); 
            setContextData(ProjectContext,"Project",ProjectName); 
            setContextData(ProjectContext,"Directory",curDir); 
	    } catch (Exception e) { System.out.println(e);}

	  // if(currentProject()) { 
          //    pageurl = ServletDir+"PSEnewSession?Project="+ProjectName;
	  //}
          //callServlet(pageurl); 
          if(currentProject()) {
             listContexts(ProjectContext,".SC","session");
	  }
          } else {
             System.out.println("NewProject: already exists");
             pageurl = ServletDir + "PSEprojectError2?Name="+ProjectName;
             callServlet(pageurl); 
	  }              

     }


      public void createNewSession() { 

          SessionContextName = (String)HTMLform.get("SessionContextName");

          SessionContextName=removeSpaces(SessionContextName);   
          SessionName=setShortName(SessionContextName);

          // create directory for this session
          curDir=getContextData(ProjectContext,"Directory");
          curDir += "/"+SessionName;
          if(remotefile.mkdir(curDir)) {  

 	   // make it easier to identify an SessionContext
          SessionContextName += ".SC";

          // verify that this session name does not already exist 
          // to be done

          // set the project as the current one
          setContextData(uc,"Session",SessionContextName);

          if(ProjectContext==null) {
             System.out.println("        ?%$#@*&=^*!@#$%");
             System.out.println(" NO PROJECT CONTEXT !!!");
	  } 

          // create a new SessionContext
          try {
          SessionContext=WebFlowContextHelper
               .narrow(ProjectContext.addNewContext(SessionContextName)); 

          //  add ContextData module to newly created context
          SessionContextData = 
          ContextDataHelper.narrow(SessionContext.addNewModule("ContextData"));
          //  store Context name in the ContextData 
          //  SessionName is fully qualified context name +.SC
          //  Session is what the user entered without spaces (shortName)
          //  Project is the current project (shortName)  


          setContextData(SessionContext,"SessionName", SessionContextName); 
          setContextData(SessionContext,"Session",SessionName); 
          setContextData(SessionContext,"Project",ProjectName); 
	  } catch (Exception e) { System.out.println(e);}

          // start session date

          currentDate = new Date();
          time = currentDate.getTime(); 
          String timestring = (new Long(time).toString());
          
          setContextData(SessionContext,"Time",timestring);  
          setContextData(SessionContext,"LastTime",timestring);  
          setContextData(SessionContext,"Directory",curDir);  

          pageurl=ServletDir+"PSEapplicationlist?Project="+ProjectName;
          pageurl+="&Session="+SessionName;
          callServlet(pageurl); 
          } else {
           System.out.println("NewSession: already exists");
           pageurl = ServletDir+"PSEsessionError2?Name="+SessionName;
           callServlet(pageurl);
	  } 
      }
      public void createNewApplication() { 

          appl="";
          appl = (String)HTMLform.get("application");
	  // the servlet actually returns name of application descriptor
	  // in the form of ApplicationName.xml  
         int idx = appl.indexOf("."); 
         ApplicationName=appl.substring(0,idx);
         ApplContextName = ApplicationName;

          ApplContextName=removeSpaces(ApplContextName);   
          ApplicationName=setShortName(ApplContextName);

	  // create directory for this application
          curDir=getContextData(SessionContext,"Directory");
          curDir += "/"+ApplicationName;
          if(remotefile.mkdir(curDir)) { 


 	   // make it easier to identify an ApplicationContext
          ApplContextName += ".AC";

          // verify that this session name does not already exist 
          // to be done


          if(ProjectContext==null) {
             System.out.println("        ?%$#@*&=^*!@#$%");
             System.out.println(" NO PROJECT CONTEXT !!!");
	  } 

          if(SessionContext==null) {
             System.out.println("        ?%$#@*&=^*!@#$%");
             System.out.println(" NO SESSION CONTEXT !!!");
	  } 

          // create a new ApplContext
          try {
          ApplContext=WebFlowContextHelper
               .narrow(SessionContext.addNewContext(ApplContextName)); 

          //  add ContextData module to newly created context
          ApplicationContextData = 
          ContextDataHelper.narrow(ApplContext.addNewModule("ContextData"));
          //  store Context name in the ContextData 
          //  ApplicationName is fully qualified context name + .AC
          //  Application is application name (shortName)
          //  ApplDesc is application descriptor (.xml) as received
          //  Session is the current session (shortName)
          //  Project is the current project (shortName)  

          setContextData(ApplContext,"ApplicationName",ApplContextName);
          setContextData(ApplContext,"Application",ApplicationName);
          setContextData(ApplContext,"ApplDesc",appl);
          setContextData(ApplContext,"Session",SessionName);
          setContextData(ApplContext,"Project",ProjectName);
          setContextData(ApplContext,"Directory",curDir);
	  } catch (Exception e) { System.out.println(e);}

          pageurl=ServletDir+"PSEinput?appl="+ApplicationName;
          pageurl+="&Project="+ProjectName; 
          pageurl+="&Session="+SessionName;

          /* attach event "submit" fired by CommandLine of XmlParser*/
          ApplContext.attachPushEvent(oxml,"submit",os,"submit");
          } else {
           System.out.println("NewApplication: already exists");
           pageurl = ServletDir+"PSEapplicationError2?Name="+SessionName;
           callServlet(pageurl);
	  } 
          

      }

     public void setContextData(WebFlowContext c, String name, String value){
         ContextData cd = findContextData(c);
         cd.setParam(name,value);

         //find the Session Context and set last updated time
         String session=""; 
         String contextName = c.getObjectID(); 
         int idx = contextName.indexOf(".SC");
         if(idx>-1) {
           session = contextName.substring(0,idx+3);
           WebFlowContext s = WebFlowContextHelper.narrow(uc.getContext(session));
           if(s==null) System.out.println("session is null"); 
           else {System.out.println("session OK!");}
           ContextData sd = findContextData(s); 
           time = (new Date()).getTime();
           String timestring = (new Long(time).toString());
           sd.setParam("LastTime",timestring);
	 }
         saveContext.saveContextData(c);
         saveContext.restoreContextData(c,DDir);
     }    

     public String getContextData(WebFlowContext c, String name) {
          ContextData cd = findContextData(c);
          String value = cd.getParam(name); 
          return value;
     }

     public void archiveProject() {
     }
     public void archiveSession() {
     }

     public FileBrowser getFileBrowser() { return filebrowser; }
     public RemoteFile  getRemoteFile()  { return remotefile;  }

   }




